/**
  *  \file planetscentral/dbclient/dbkey.h
  *  \brief Database Client: Key
  */
#ifndef C2SERVER_PLANETSCENTRAL_DBCLIENT_DBKEY_H
#define C2SERVER_PLANETSCENTRAL_DBCLIENT_DBKEY_H

#include "cpluslib/string.h"

class DbClient;
class IntValue;

/** A redis database key. */
class DbKey {
 public:
    enum Type {
        None,
        String,
        List,
        Set,
        ZSet,
        Hash,
        Unknown
    };

    DbKey(DbClient& client, const string_t& s);
    ~DbKey();

    bool exists();
    void remove();
    void rename(string_t newName);
    bool renameNX(string_t newName);
    Type getType();

    const string_t& getName() const;
    DbClient& getClient();

 protected:
    DbClient& client;
    string_t key;
};

#endif
